---@class SZVector
SZVector = {}

---@param isoObject zombie.iso.IsoObject?
---@return SZVector
function SZVector:new(isoObject)
    local obj = {}
    setmetatable(obj, self)
    self.__index = self

    if isoObject ~= nil then
        obj.x = isoObject:getX()
        obj.y = isoObject:getY()
        obj.z = isoObject:getZ()
    end

    return obj
end

---@param vec SZVector
---@return SZVector
function SZVector:sub(vec)
    local newVec = SZVector:new()
    newVec.x = self.x - vec.x
    newVec.y = self.y - vec.y
    newVec.z = self.z - vec.z
    return newVec
end

---@return number
function SZVector:mag()
    return math.sqrt(self.x * self.x + self.y * self.y + self.z * self.z)
end

function SZVector:normalise()
    local mag = self:mag()
    self.x = self.x / mag
    self.y = self.y / mag
    self.z = self.z / mag
end

---@return number
function SZVector:dot(vec)
    return self.x * vec.x + self.y * vec.y
end
